export = logoutUser;
/**
 * Logout user
 * ==============================================================================
 * @param {object} params - Single Param object containing params
 * @param {string} [params.encryptedUserString] - Encrypted User String
 * @param {http.IncomingMessage & Object<string, any>} [params.request] - Request Object
 * @param {http.ServerResponse & Object<string, any>} [params.response] - Http response object
 * @param {string} [params.database] - Target database name(slug): optional
 * @param {string | number} [params.dsqlUserId]
 *
 * @returns {{success: boolean, msg: string, cookieNames?: any}}
 */
declare function logoutUser({ response, database, dsqlUserId, encryptedUserString, request, }: {
    encryptedUserString?: string;
    request?: http.IncomingMessage & {
        [x: string]: any;
    };
    response?: http.ServerResponse & {
        [x: string]: any;
    };
    database?: string;
    dsqlUserId?: string | number;
}): {
    success: boolean;
    msg: string;
    cookieNames?: any;
};
import http = require("http");
